/*
 * $Id: reactionprefs.c,v 1.1.1.1 2005/03/15 16:01:01 laire Exp $
 */
#define AROS_ALMOST_COMPATIBLE
#include "global.h"
#include <exec/execbase.h>
#include <reaction/reaction_prefs.h>
#include <proto/iffparse.h>
#include <aros/asmcall.h>

#define DEBUG 0
#include <aros/debug.h>

extern struct ExecBase *SysBase;


struct UIPrefsBuffer
{
	struct UIPrefs  b_UIP;
	struct TextAttr b_FallbackAttr;
	UBYTE           b_FallbackAttrName[FONTNAMESIZE];
	struct TextAttr b_LabelAttr;
	UBYTE           b_LabelAttrName[FONTNAMESIZE];
};


#define BEVEL_Function8() \
	LP0(48, void *, BEVEL_Function8, \
		, BevelBase, 0, 0, 0, 0, 0, 0)

#define WINDOW_Function6() \
	LP0(36, void *, WINDOW_Function6, \
		, WindowBase, 0, 0, 0, 0, 0, 0)


AROS_UFH1(LONG, ReactionPrefs_Handler,
		  AROS_UFHA(struct IFFHandle *, iff, A2))
{
	struct ReactionPrefs rprefs;
	struct UIPrefs *UIPrefs;
	BOOL PrefsOk;
	struct Library *BevelBase;
	struct Library *WindowBase;

	if (ReadChunkBytes(iff, &rprefs, sizeof(rprefs)) != sizeof(rprefs))
	{
		return 1;
	}

	Forbid();
	UIPrefs = (struct UIPrefs *) FindSemaphore(RAPREFSSEMAPHORE);
	if (!UIPrefs)
	{
		UIPrefs = AllocVec(sizeof(struct UIPrefsBuffer) + sizeof(RAPREFSSEMAPHORE) + 1,
		                   MEMF_PUBLIC | MEMF_CLEAR);
		if (UIPrefs)
		{
			UIPrefs->cap_Semaphore.ss_Link.ln_Pri  = 20;
			UIPrefs->cap_Semaphore.ss_Link.ln_Name = ((UBYTE *) UIPrefs) + sizeof(struct UIPrefsBuffer);
			strcpy(UIPrefs->cap_Semaphore.ss_Link.ln_Name, RAPREFSSEMAPHORE);

			UIPrefs->cap_PrefsVersion = 1;
			UIPrefs->cap_PrefsSize    = sizeof(struct UIPrefs);

			UIPrefs->cap_FallbackAttr = &((struct UIPrefsBuffer *) UIPrefs)->b_FallbackAttr;
			((struct UIPrefsBuffer *) UIPrefs)->b_FallbackAttr.ta_Name =
				((struct UIPrefsBuffer *) UIPrefs)->b_FallbackAttrName;

			UIPrefs->cap_LabelAttr    = &((struct UIPrefsBuffer *) UIPrefs)->b_LabelAttr;
			((struct UIPrefsBuffer *) UIPrefs)->b_LabelAttr.ta_Name =
				((struct UIPrefsBuffer *) UIPrefs)->b_LabelAttrName;

			AddSemaphore(&UIPrefs->cap_Semaphore);
		}
	}

	PrefsOk = FALSE;
	BevelBase = NULL;
	WindowBase = NULL;

	if (UIPrefs)
	{
		ObtainSemaphore(&UIPrefs->cap_Semaphore);
		Permit();

		if (UIPrefs->cap_PrefsSize >= sizeof(struct UIPrefs))
		{
			UIPrefs->cap_BevelType     = rprefs.rp_BevelType;
			UIPrefs->cap_LayoutSpacing = rprefs.rp_LayoutSpacing;
			UIPrefs->cap_LabelPen      = rprefs.rp_LabelPen;
			UIPrefs->cap_LabelPlace    = rprefs.rp_LabelPlace;
			UIPrefs->cap_3DLabel       = rprefs.rp_3DLabel;
			UIPrefs->cap_SimpleRefresh = rprefs.rp_SimpleRefresh;
			UIPrefs->cap_3DProp        = rprefs.rp_3DProp;

			strcpy(UIPrefs->cap_FallbackAttr->ta_Name, rprefs.rp_FallbackName);
			UIPrefs->cap_FallbackAttr->ta_YSize = rprefs.rp_FallbackAttr.ta_YSize;
			UIPrefs->cap_FallbackAttr->ta_Style = rprefs.rp_FallbackAttr.ta_Style;
			UIPrefs->cap_FallbackAttr->ta_Flags = rprefs.rp_FallbackAttr.ta_Flags;

			strcpy(UIPrefs->cap_LabelAttr->ta_Name, rprefs.rp_LabelName);
			UIPrefs->cap_LabelAttr->ta_YSize    = rprefs.rp_LabelAttr.ta_YSize;
			UIPrefs->cap_LabelAttr->ta_Style    = rprefs.rp_LabelAttr.ta_Style;
			UIPrefs->cap_LabelAttr->ta_Flags    = rprefs.rp_LabelAttr.ta_Flags;

			strcpy(UIPrefs->cap_Pattern, rprefs.rp_Pattern);

			PrefsOk = TRUE;
		}

		ReleaseSemaphore(&UIPrefs->cap_Semaphore);

		if (PrefsOk)
		{
			Forbid();

			if (FindName(&SysBase->LibList, "bevel.image"))
			{
				BevelBase = OpenLibrary("bevel.image", 40);
			}

			if (FindName(&SysBase->LibList, "window.class"))
			{
				WindowBase = OpenLibrary("window.class", 40);
			}

			Permit();
		}
	}
	else
		Permit();

	if (BevelBase)
	{
		BEVEL_Function8();

		CloseLibrary(BevelBase);
		BevelBase = NULL;
	}

	if (WindowBase)
	{
		WINDOW_Function6();

		CloseLibrary(WindowBase);
		WindowBase = NULL;
	}

	return !PrefsOk;

	AROS_LIBFUNC_EXIT
}

